/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class lw extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         lw.class,
         "lw",
         false,
         new ArgumentDecls()
             .add("rt", ArgumentMode.OUT, REG.INFO)
             .add("offset", SHORT)
             .add("address", ArgumentMode.IN, REG.INFO),
         false,
         false,
         false,
         true,
         false,
         32,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final REG rt = (REG) getArgument("rt", args);
      final Location offset = (Location) getArgument("offset", args);
      final REG address = (REG) getArgument("address", args);

      return new lw(rt, offset, address);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "lw",
          true,
          new ArgumentDecls()
              .add("rt", ArgumentMode.OUT, REG.INFO)
              .add("offset", SHORT)
              .add("address", ArgumentMode.IN, REG.INFO),
          true,
          true,
          false,
          true,
          false,
          32
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final REG rt = (REG) getArgument("rt", args);
      final Location offset = (Location) getArgument("offset", args);
      final REG address = (REG) getArgument("address", args);

      return new instruction(
        new lw(
          rt,
          offset,
          address
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  private final REG rt;
  private final Location offset;
  private final REG address;

  public lw(REG rt, Location offset, REG address) {
    assert REG.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());
    assert REG.INFO.isSupported(address);

    this.rt = rt;
    this.offset = offset;
    this.address = address;
  }

  @Override
  public String syntax() {
    return String.format("lw %s, %d(%s)", rt.syntax(), offset.load().bigIntegerValue(), address.syntax());
  }

  @Override
  public String image() {
    return String.format("100011%s%s%s", address.image(), rt.image(), offset.load().toString());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    rt.access().store(M.access(address.access().load().add(Data.signExtend(WORD, offset.load())).shiftRight(Data.valueOf(WORD, 0x2))).load());
    } finally {
    actionEnd();
    }
  }
}
